// //////////////////////////////////////////////////////////////////////
// Import section
// //////////////////////////////////////////////////////////////////////
// STL
#include <cassert>
#include <sstream>
// StdAir
#include <stdair/basic/BasConst_Inventory.hpp>
#include <stdair/bom/BookingClassKey.hpp>

namespace stdair {

  // ////////////////////////////////////////////////////////////////////
  BookingClassKey::BookingClassKey() : _classCode (DEFAULT_CLASS_CODE) {
    assert (false);
  }

  // ////////////////////////////////////////////////////////////////////
  BookingClassKey::BookingClassKey (const BookingClassKey& iKey)
    : _classCode (iKey._classCode) {
  }

  // ////////////////////////////////////////////////////////////////////
  BookingClassKey::BookingClassKey (const ClassCode_T& iClassCode)
    : _classCode (iClassCode) {
  }

  // ////////////////////////////////////////////////////////////////////
  BookingClassKey::~BookingClassKey () {
  }

  // ////////////////////////////////////////////////////////////////////
  void BookingClassKey::toStream (std::ostream& ioOut) const {
    ioOut << "BookingClassKey: " << toString();
  }

  // ////////////////////////////////////////////////////////////////////
  void BookingClassKey::fromStream (std::istream& ioIn) {
  }

  // ////////////////////////////////////////////////////////////////////
  const std::string BookingClassKey::toString() const {
    std::ostringstream oStr;
    oStr << _classCode;
    return oStr.str();
  }

}
