// //////////////////////////////////////////////////////////////////////
// Import section
// //////////////////////////////////////////////////////////////////////
// STL
#include <cassert>
#include <sstream>
// StdAir
#include <stdair/basic/BasConst_General.hpp>
#include <stdair/bom/BreakPointStruct.hpp>

namespace stdair {
  
  // //////////////////////////////////////////////////////////////////////
  BreakPointStruct::BreakPointStruct() {
    assert (false);
  }
    
  // //////////////////////////////////////////////////////////////////////
  BreakPointStruct::
  BreakPointStruct (const BreakPointStruct& iBreakPoint)
    : _breakPointTime (iBreakPoint._breakPointTime) {
  }
  
  // //////////////////////////////////////////////////////////////////////
  BreakPointStruct::
  BreakPointStruct (const DateTime_T& iBreakPointTime)
    : _breakPointTime (iBreakPointTime) {
  }  

  // //////////////////////////////////////////////////////////////////////
  BreakPointStruct::
  BreakPointStruct (const Date_T& iBreakPointDate)
    : _breakPointTime (iBreakPointDate, DEFAULT_NULL_DURATION) {
  }
  
  // //////////////////////////////////////////////////////////////////////
  BreakPointStruct::~BreakPointStruct() {
  }
  
  // //////////////////////////////////////////////////////////////////////
  void BreakPointStruct::toStream (std::ostream& ioOut) const {
    ioOut << describe();
  }

  // //////////////////////////////////////////////////////////////////////
  void BreakPointStruct::fromStream (std::istream& ioIn) {
  }
  
  // //////////////////////////////////////////////////////////////////////
  const std::string BreakPointStruct::describe() const {
    std::ostringstream oStr;
    oStr << _breakPointTime;
    return oStr.str();
  }

}
